//水质数据
var waterQualityData = [{
	"value": "32",
	"name": "北潦河",
	"level": "I类",
	"type": "1",
	"lastmonthlevel": "II类"
}, {
	"value": "47",
	"name": "罗湾水库",
	"level": "II类",
	"type": "1",
	"lastmonthlevel": "IV类"
}, {
	"value": "48 ",
	"name": "北河",
	"level": "III类",
	"type": "2",
	"lastmonthlevel": "II类"
}, {
	"value": "41",
	"name": "梅源水库",
	"level": "II类",
	"type": "2",
	"lastmonthlevel": "I类"
}, {
	"value": "28",
	"name": "石马水库",
	"level": "V类",
	"type": "2",
	"lastmonthlevel": "IV类"
}, {
	"value": "115",
	"name": "安全水库",
	"level": "劣V类",
	"type": "2",
	"lastmonthlevel": "II类"
}]

//事件统计
var eventStatisticsData = {
	"hzList": [{
		"name": "已完成事件",
		"value": 356
	}, {
		"name": "未完成事件",
		"value": 225
	}],
	"grList": [{
		"name": "事件总数",
		"value": 27
	}, {
		"name": "已完成事件",
		"value": 13
	}, {
		"name": "未完成事件",
		"value": 14
	}]
};

//水文数据
var hydrologyData = {
	"swList": [
		// {
		// 	"cityName": "城市",
		// 	"riversName": "河流",
		// 	"section": "断面",
		// 	"createtime": "时间",
		// 	"waterlevel": "水位",
		// 	"rainfall": "降雨量mm",
		// 	"longitude": "经度",
		// 	"latitude": "纬度"
		// },
		{
			"cityName": "靖安县",
			"riversName": "北潦河",
			"section": "上阜头",
			"createtime": "2020-04-02 20:00",
			"waterlevel": "12.2",
			"rainfall": "18",
			"type":"1",
			"longitude": "115.170796",
			"latitude": "28.956987"
		},
		{
			"cityName": "靖安县",
			"riversName": "罗湾水库",
			"section": "罗湾水库",
			"createtime": "2020-04-02 08:00",
			"waterlevel": "72.5",
			"rainfall": "20",
			"type":"2",
			"longitude": "115.116566",
			"latitude": "28.971066"
		},
		{
			"cityName": "靖安县",
			"riversName": "北河",
			"section": "小湾水库",
			"createtime": "2020-04-02 12:00",
			"waterlevel": "55.3",
			"rainfall": "22",
			"type":"2",
			"longitude": "115.397377",
			"latitude": "29.028972"
		},
		{
			"cityName": "靖安县",
			"riversName": "梅源水库",
			"section": "梅源水库",
			"createtime": "2020-04-02 08:00",
			"waterlevel": "65.9",
			"rainfall": "23",
			"type":"2",
			"longitude": "115.444336",
			"latitude": "28.899996"
		},
		{
			"cityName": "靖安县",
			"riversName": "石马水库",
			"section": "石马水库",
			"createtime": "2020-04-02 08:00",
			"waterlevel": "56.2",
			"rainfall": "20",
			"type":"2",
			"longitude": "115.322921",
			"latitude": "28.848362"
		},
		{
			"cityName": "靖安县",
			"riversName": "安全水库",
			"section": "安全水库",
			"createtime": "2020-04-02 08:00",
			"waterlevel": "67.4",
			"rainfall": "20",
			"type":"2",
			"longitude": "115.371148",
			"latitude": "28.804321"
		}
	],
	"lnList": [{
			"code": "ll001",
			"name": "熊家桥",
			"lon": "115.411183",
			"lat": "29.016141",
			"rivers": "北河",
			"operation": "异常",
			"flow": "100",
			"strength": "4.5"
		},
		{
			"code": "ll002",
			"name": "宝峰交警支队",
			"lon": "115.405645",
			"lat": "29.000327",
			"rivers": "北河",
			"operation": "正常",
			"flow": "92",
			"strength": "4.1"
		},
		{
			"code": "ll003",
			"name": "宝田村村委会",
			"lon": "115.397466",
			"lat": "28.986473",
			"rivers": "北河",
			"operation": "正常",
			"flow": "95",
			"strength": "4.3"
		},
		{
			"code": "ll004",
			"name": "三爪仑公园漂流",
			"lon": "115.409818",
			"lat": "28.97257",
			"rivers": "北河",
			"operation": "正常",
			"flow": "87",
			"strength": "4"
		},
		{
			"code": "ll005",
			"name": "周朗村村委会",
			"lon": "115.425789",
			"lat": "28.942965",
			"rivers": "北河",
			"operation": "正常",
			"flow": "62",
			"strength": "3.2"
		},
		{
			"code": "ll006",
			"name": "仁首镇",
			"lon": "115.491581",
			"lat": "28.877705",
			"rivers": "北河",
			"operation": "正常",
			"flow": "73",
			"strength": "3.8"
		},
		{
			"code": "ll007",
			"name": "台山陈家",
			"lon": "115.519716",
			"lat": "28.851798",
			"rivers": "北河",
			"operation": "正常",
			"flow": "65",
			"strength": "3.5"
		},
		{
			"code": "ll008",
			"name": "上埠头",
			"lon": "115.171497",
			"lat": "28.957172",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "45",
			"strength": "2"
		},
		{
			"code": "ll009",
			"name": "靖安恒茂御泉谷国际度假山庄",
			"lon": "115.195298",
			"lat": "28.945984",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "63",
			"strength": "3.2"
		},
		{
			"code": "ll010",
			"name": "下观村",
			"lon": "115.226294",
			"lat": "28.946664",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "65",
			"strength": "3.5"
		},
		{
			"code": "ll011",
			"name": "宜春市公路管理局(高湖道班)",
			"lon": "115.251931",
			"lat": "28.937331",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "57",
			"strength": "3"
		},
		{
			"code": "ll012",
			"name": "土门中桥",
			"lon": "115.297148",
			"lat": "28.912399",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "56",
			"strength": "3.1"
		},
		{
			"code": "ll013",
			"name": "清湖广场",
			"lon": "115.358996",
			"lat": "28.868172",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "70",
			"strength": "3.7"
		},
		{
			"code": "ll014",
			"name": "靖安县水务局",
			"lon": "115.369106",
			"lat": "28.869125",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "64",
			"strength": "3.5"
		},
		{
			"code": "ll015",
			"name": "靖安大桥",
			"lon": "115.375871",
			"lat": "28.871664",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "61",
			"strength": "3.2"
		},
		{
			"code": "ll016",
			"name": "清华大桥",
			"lon": "115.384917",
			"lat": "28.861925",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "57",
			"strength": "3"
		},
		{
			"code": "ll017",
			"name": "九岭大桥",
			"lon": "115.393105",
			"lat": "28.838976",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "59",
			"strength": "3.2"
		},
		{
			"code": "ll018",
			"name": "靖安路政巡查大队",
			"lon": "115.390005",
			"lat": "28.82783",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "71",
			"strength": "3.7"
		},
		{
			"code": "ll019",
			"name": "香田派出所",
			"lon": "115.405708",
			"lat": "28.819468",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "68",
			"strength": "3.6"
		},
		{
			"code": "ll020",
			"name": "洲尾",
			"lon": "115.520233",
			"lat": "28.844822",
			"rivers": "北潦河",
			"operation": "正常",
			"flow": "60",
			"strength": "3.1"
		}
	],
	"lsList": [{
		"name": "河流1",
		"value": 14
	}, {
		"name": "河流1",
		"value": 13
	}, {
		"name": "河流1",
		"value": 14
	}, {
		"name": "河流1",
		"value": 16
	}, {
		"name": "河流1",
		"value": 16
	}, {
		"name": "河流1",
		"value": 21
	}, {
		"name": "河流1",
		"value": 25
	}, {
		"name": "河流1",
		"value": 22
	}, {
		"name": "河流1",
		"value": 23
	}, {
		"name": "河流1",
		"value": 24
	}, {
		"name": "河流1",
		"value": 31
	}, {
		"name": "河流1",
		"value": 34
	}, {
		"name": "河流1",
		"value": 35
	}, {
		"name": "河流1",
		"value": 37
	}, {
		"name": "河流1",
		"value": 37
	}, {
		"name": "河流1",
		"value": 37
	}]
};

//雨情数据
var rainfallConditionData = [{
	"area": "05月09日",
	"data": 10
}, {
	"area": "05月08日",
	"data": 52
}, {
	"area": "05月07日",
	"data": 200
}, {
	"area": "05月06日",
	"data": 334
}, {
	"area": "05月05日",
	"data": 390
}, {
	"area": "05月04日",
	"data": 330
}, {
	"area": "05月03日",
	"data": 23
}, {
	"area": "05月02日",
	"data": 44
}, {
	"area": "05月01日",
	"data": 134
}];
