var carmarker;

function setCarmarker(lineArr) {
	document.getElementById('trackPlaydiv').style.display = "block";
	//坐标转换
	AMap.convertFrom(lineArr[0], 'baidu', function(status, result) {
		if (result.info === 'ok') {
			var resLnglat = result.locations[0];
			carmarker = new AMap.Marker({
				map: map,
				position: resLnglat,
				icon: new AMap.Icon({
					size: new AMap.Size(60, 60), // 图标尺寸
					image: "../../../images/car.png", // Icon的图像
					imageSize: new AMap.Size(60, 60), // 根据所设置的大小拉伸或压缩图片
				}),
				offset: new AMap.Pixel(-31, -58),
				autoRotation: false
			});
			carmarker.on('click', function(e) {
				// infoWindow.open(map, marker.getPosition());
			});
			carmarker.on('moving', function(e) {
				// var len = e.passedPath.length;
				// var rate = res.data[len - 1].rate;
				// var location = e.passedPath[len - 1];
				// var lll = new AMap.LngLat(location.lng, location.lat);
				// 坐标转换
				// AMap.convertFrom(e.passedPath, "baidu", function(status, result) {
				// 	if (result.info === 'ok') {
				// 		var path2 = result.locations;
				// 		passedPolyline.setPath(path2);
				// 	}
				// });
				passedPolyline.setPath(e.passedPath);
			})
			map.setFitView();
			// map.setCenter(resLnglat);
			// map.setZoom(13);
			map.setZoomAndCenter(15, resLnglat); //同时设置地图层级与中心点
		}
	});
	var polyline;
	var passedPolyline;
	// 坐标转换
	AMap.convertFrom(lineArr, "baidu", function(status, result) {
		if (result.info === 'ok') {
			var path2 = result.locations;
			// 绘制轨迹
			polyline = new AMap.Polyline({
				map: map,
				path: path2,
				strokeColor: "#0000AA", //线颜色
				strokeOpacity: 1, //线透明度
				// strokeWeight: 3, //线宽
				// strokeStyle: "solid" //线样式
			});

			passedPolyline = new AMap.Polyline({
				map: map,
				//path: lineArr,
				strokeColor: "#FF0000", //线颜色
				//strokeOpacity: 1, //线透明度
				strokeWeight: 3, //线宽
				//strokeStyle: "solid" //线样式
			});
		}
	});

}


// AMapUI.loadUI(['overlay/SimpleInfoWindow'], function(SimpleInfoWindow) {
// 	infoWindow = new SimpleInfoWindow({
// 		infoTitle: '<strong>标题</strong>',
// 		infoBody: '点击开始动画可进行播放',
// 		//基点指向marker的头部位置
// 		offset: new AMap.Pixel(0, -31)
// 	});
// 	infoWindow.open(map, marker.getPosition());
// })
var ifMove = false;
AMap.event.addDomListener(document.getElementById('move'), 'click', function() {
	if (carmarker == undefined) {
		return;
	}
	if (carmarker.pauseMove()) {
		if (ifMove) {
			carmarker.pauseMove();
			ifMove = false;
			document.getElementById('move').src = "../../../images/icon_move_p.png";
			document.getElementById('stop').src = "../../../images/icon_stop_n.png";
		} else {
			carmarker.resumeMove();
			ifMove = true;
			document.getElementById('move').src = "../../../images/icon_play_p.png";
			document.getElementById('stop').src = "../../../images/icon_stop_n.png";
		}
	} else {
		AMap.convertFrom(lineArr, "baidu", function(status, result) {
			if (result.info === 'ok') {
				var path2 = result.locations;
				carmarker.moveAlong(path2, 1000, function(k) {
					return k;
				});
			}
		});
		ifMove = true;
		document.getElementById('move').src = "../../../images/icon_play_p.png";
		document.getElementById('stop').src = "../../../images/icon_stop_n.png";
	}
}, false);

// AMap.event.addDomListener(document.getElementById('pause'), 'click', function() {
// 	if (carmarker == undefined) {
// 		return;
// 	}
// 	carmarker.pauseMove();
// 	document.getElementById('move').src = "../../../images/icon_move_n.png";
// 	document.getElementById('pause').src = "../../../images/icon_stop_p.png";
// }, false);

// AMap.event.addDomListener(document.getElementById('resume'), 'click', function() {
// 	if (carmarker == undefined) {
// 		return;
// 	}
// 	carmarker.resumeMove();
// 	document.getElementById('move').className = "mui-btn mui-btn-green mui-btn-outlined";
// 	document.getElementById('pause').className = "mui-btn mui-btn-blue mui-btn-outlined";
// 	document.getElementById('resume').className = "mui-btn mui-btn-yellow";
// 	document.getElementById('stop').className = "mui-btn mui-btn-danger mui-btn-outlined";
// }, false);

AMap.event.addDomListener(document.getElementById('stop'), 'click', function() {
	if (carmarker == undefined) {
		return;
	}
	carmarker.stopMove();
	document.getElementById('move').src = "../../../images/icon_move_n.png";
	document.getElementById('stop').src = "../../../images/icon_stop_p.png";
}, false);
